/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmTransposeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmTranspose extends TableImpl<VDmTransposeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_transpose</code>
     */
    public static final VDmTranspose V_DM_TRANSPOSE = new VDmTranspose();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmTransposeRecord> getRecordType() {
        return VDmTransposeRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_transpose.fk_element</code>.
     */
    public final TableField<VDmTransposeRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_transpose.schemaname</code>.
     */
    public final TableField<VDmTransposeRecord, String> SCHEMANAME = createField(DSL.name("schemaname"), SQLDataType.CLOB, this, "");

    private VDmTranspose(Name alias, Table<VDmTransposeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmTranspose(Name alias, Table<VDmTransposeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_transpose" as  SELECT t_dm_tabledef.fk_element,
         t_dm_tabledef.schemaname
        FROM (common_dd.t_dm_tabledef
          JOIN common_dd.t_dm_transpose ON ((t_dm_transpose.fk_tabledef = t_dm_tabledef.pk)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_transpose</code> table reference
     */
    public VDmTranspose(String alias) {
        this(DSL.name(alias), V_DM_TRANSPOSE);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_transpose</code> table reference
     */
    public VDmTranspose(Name alias) {
        this(alias, V_DM_TRANSPOSE);
    }

    /**
     * Create a <code>common_dd.v_dm_transpose</code> table reference
     */
    public VDmTranspose() {
        this(DSL.name("v_dm_transpose"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmTranspose as(String alias) {
        return new VDmTranspose(DSL.name(alias), this);
    }

    @Override
    public VDmTranspose as(Name alias) {
        return new VDmTranspose(alias, this);
    }

    @Override
    public VDmTranspose as(Table<?> alias) {
        return new VDmTranspose(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTranspose rename(String name) {
        return new VDmTranspose(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTranspose rename(Name name) {
        return new VDmTranspose(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTranspose rename(Table<?> name) {
        return new VDmTranspose(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose where(Condition condition) {
        return new VDmTranspose(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTranspose where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTranspose where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTranspose where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTranspose where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTranspose whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
